<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DealPendingApprovalDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DealPendingApprovalDetails
 * @subpackage Structs
 */
class DealPendingApprovalDetails extends AbstractStructBase
{
    /**
     * The AFXDealID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AFXDealID;
    /**
     * The AFXPaymentID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AFXPaymentID;
    /**
     * The CallDateTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CallDateTime;
    /**
     * The DebitAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $DebitAmount;
    /**
     * The FXAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $FXAmount;
    /**
     * The FXCurrencyID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FXCurrencyID;
    /**
     * The Fee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Fee;
    /**
     * The InitiatedBy
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InitiatedBy;
    /**
     * The OrgID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OrgID;
    /**
     * The OriginatorAccountNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OriginatorAccountNumber;
    /**
     * The OriginatorName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OriginatorName;
    /**
     * The PaymentReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PaymentReference;
    /**
     * The Rate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Rate;
    /**
     * The SettlementCurrencyID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SettlementCurrencyID;
    /**
     * The TransactionDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TransactionDate;
    /**
     * The YourInternalReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $YourInternalReference;
    /**
     * Constructor method for DealPendingApprovalDetails
     * @uses DealPendingApprovalDetails::setAFXDealID()
     * @uses DealPendingApprovalDetails::setAFXPaymentID()
     * @uses DealPendingApprovalDetails::setCallDateTime()
     * @uses DealPendingApprovalDetails::setDebitAmount()
     * @uses DealPendingApprovalDetails::setFXAmount()
     * @uses DealPendingApprovalDetails::setFXCurrencyID()
     * @uses DealPendingApprovalDetails::setFee()
     * @uses DealPendingApprovalDetails::setInitiatedBy()
     * @uses DealPendingApprovalDetails::setOrgID()
     * @uses DealPendingApprovalDetails::setOriginatorAccountNumber()
     * @uses DealPendingApprovalDetails::setOriginatorName()
     * @uses DealPendingApprovalDetails::setPaymentReference()
     * @uses DealPendingApprovalDetails::setRate()
     * @uses DealPendingApprovalDetails::setSettlementCurrencyID()
     * @uses DealPendingApprovalDetails::setTransactionDate()
     * @uses DealPendingApprovalDetails::setYourInternalReference()
     * @param string $aFXDealID
     * @param string $aFXPaymentID
     * @param string $callDateTime
     * @param float $debitAmount
     * @param float $fXAmount
     * @param string $fXCurrencyID
     * @param float $fee
     * @param string $initiatedBy
     * @param string $orgID
     * @param string $originatorAccountNumber
     * @param string $originatorName
     * @param string $paymentReference
     * @param float $rate
     * @param string $settlementCurrencyID
     * @param string $transactionDate
     * @param string $yourInternalReference
     */
    public function __construct($aFXDealID = null, $aFXPaymentID = null, $callDateTime = null, $debitAmount = null, $fXAmount = null, $fXCurrencyID = null, $fee = null, $initiatedBy = null, $orgID = null, $originatorAccountNumber = null, $originatorName = null, $paymentReference = null, $rate = null, $settlementCurrencyID = null, $transactionDate = null, $yourInternalReference = null)
    {
        $this
            ->setAFXDealID($aFXDealID)
            ->setAFXPaymentID($aFXPaymentID)
            ->setCallDateTime($callDateTime)
            ->setDebitAmount($debitAmount)
            ->setFXAmount($fXAmount)
            ->setFXCurrencyID($fXCurrencyID)
            ->setFee($fee)
            ->setInitiatedBy($initiatedBy)
            ->setOrgID($orgID)
            ->setOriginatorAccountNumber($originatorAccountNumber)
            ->setOriginatorName($originatorName)
            ->setPaymentReference($paymentReference)
            ->setRate($rate)
            ->setSettlementCurrencyID($settlementCurrencyID)
            ->setTransactionDate($transactionDate)
            ->setYourInternalReference($yourInternalReference);
    }
    /**
     * Get AFXDealID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAFXDealID()
    {
        return isset($this->AFXDealID) ? $this->AFXDealID : null;
    }
    /**
     * Set AFXDealID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $aFXDealID
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setAFXDealID($aFXDealID = null)
    {
        // validation for constraint: string
        if (!is_null($aFXDealID) && !is_string($aFXDealID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aFXDealID, true), gettype($aFXDealID)), __LINE__);
        }
        if (is_null($aFXDealID) || (is_array($aFXDealID) && empty($aFXDealID))) {
            unset($this->AFXDealID);
        } else {
            $this->AFXDealID = $aFXDealID;
        }
        return $this;
    }
    /**
     * Get AFXPaymentID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAFXPaymentID()
    {
        return isset($this->AFXPaymentID) ? $this->AFXPaymentID : null;
    }
    /**
     * Set AFXPaymentID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $aFXPaymentID
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setAFXPaymentID($aFXPaymentID = null)
    {
        // validation for constraint: string
        if (!is_null($aFXPaymentID) && !is_string($aFXPaymentID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aFXPaymentID, true), gettype($aFXPaymentID)), __LINE__);
        }
        if (is_null($aFXPaymentID) || (is_array($aFXPaymentID) && empty($aFXPaymentID))) {
            unset($this->AFXPaymentID);
        } else {
            $this->AFXPaymentID = $aFXPaymentID;
        }
        return $this;
    }
    /**
     * Get CallDateTime value
     * @return string|null
     */
    public function getCallDateTime()
    {
        return $this->CallDateTime;
    }
    /**
     * Set CallDateTime value
     * @param string $callDateTime
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setCallDateTime($callDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($callDateTime) && !is_string($callDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callDateTime, true), gettype($callDateTime)), __LINE__);
        }
        $this->CallDateTime = $callDateTime;
        return $this;
    }
    /**
     * Get DebitAmount value
     * @return float|null
     */
    public function getDebitAmount()
    {
        return $this->DebitAmount;
    }
    /**
     * Set DebitAmount value
     * @param float $debitAmount
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setDebitAmount($debitAmount = null)
    {
        // validation for constraint: float
        if (!is_null($debitAmount) && !(is_float($debitAmount) || is_numeric($debitAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($debitAmount, true), gettype($debitAmount)), __LINE__);
        }
        $this->DebitAmount = $debitAmount;
        return $this;
    }
    /**
     * Get FXAmount value
     * @return float|null
     */
    public function getFXAmount()
    {
        return $this->FXAmount;
    }
    /**
     * Set FXAmount value
     * @param float $fXAmount
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setFXAmount($fXAmount = null)
    {
        // validation for constraint: float
        if (!is_null($fXAmount) && !(is_float($fXAmount) || is_numeric($fXAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($fXAmount, true), gettype($fXAmount)), __LINE__);
        }
        $this->FXAmount = $fXAmount;
        return $this;
    }
    /**
     * Get FXCurrencyID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFXCurrencyID()
    {
        return isset($this->FXCurrencyID) ? $this->FXCurrencyID : null;
    }
    /**
     * Set FXCurrencyID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fXCurrencyID
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setFXCurrencyID($fXCurrencyID = null)
    {
        // validation for constraint: string
        if (!is_null($fXCurrencyID) && !is_string($fXCurrencyID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fXCurrencyID, true), gettype($fXCurrencyID)), __LINE__);
        }
        if (is_null($fXCurrencyID) || (is_array($fXCurrencyID) && empty($fXCurrencyID))) {
            unset($this->FXCurrencyID);
        } else {
            $this->FXCurrencyID = $fXCurrencyID;
        }
        return $this;
    }
    /**
     * Get Fee value
     * @return float|null
     */
    public function getFee()
    {
        return $this->Fee;
    }
    /**
     * Set Fee value
     * @param float $fee
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setFee($fee = null)
    {
        // validation for constraint: float
        if (!is_null($fee) && !(is_float($fee) || is_numeric($fee))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($fee, true), gettype($fee)), __LINE__);
        }
        $this->Fee = $fee;
        return $this;
    }
    /**
     * Get InitiatedBy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInitiatedBy()
    {
        return isset($this->InitiatedBy) ? $this->InitiatedBy : null;
    }
    /**
     * Set InitiatedBy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $initiatedBy
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setInitiatedBy($initiatedBy = null)
    {
        // validation for constraint: string
        if (!is_null($initiatedBy) && !is_string($initiatedBy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($initiatedBy, true), gettype($initiatedBy)), __LINE__);
        }
        if (is_null($initiatedBy) || (is_array($initiatedBy) && empty($initiatedBy))) {
            unset($this->InitiatedBy);
        } else {
            $this->InitiatedBy = $initiatedBy;
        }
        return $this;
    }
    /**
     * Get OrgID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrgID()
    {
        return isset($this->OrgID) ? $this->OrgID : null;
    }
    /**
     * Set OrgID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orgID
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setOrgID($orgID = null)
    {
        // validation for constraint: string
        if (!is_null($orgID) && !is_string($orgID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orgID, true), gettype($orgID)), __LINE__);
        }
        if (is_null($orgID) || (is_array($orgID) && empty($orgID))) {
            unset($this->OrgID);
        } else {
            $this->OrgID = $orgID;
        }
        return $this;
    }
    /**
     * Get OriginatorAccountNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOriginatorAccountNumber()
    {
        return isset($this->OriginatorAccountNumber) ? $this->OriginatorAccountNumber : null;
    }
    /**
     * Set OriginatorAccountNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $originatorAccountNumber
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setOriginatorAccountNumber($originatorAccountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($originatorAccountNumber) && !is_string($originatorAccountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originatorAccountNumber, true), gettype($originatorAccountNumber)), __LINE__);
        }
        if (is_null($originatorAccountNumber) || (is_array($originatorAccountNumber) && empty($originatorAccountNumber))) {
            unset($this->OriginatorAccountNumber);
        } else {
            $this->OriginatorAccountNumber = $originatorAccountNumber;
        }
        return $this;
    }
    /**
     * Get OriginatorName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOriginatorName()
    {
        return isset($this->OriginatorName) ? $this->OriginatorName : null;
    }
    /**
     * Set OriginatorName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $originatorName
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setOriginatorName($originatorName = null)
    {
        // validation for constraint: string
        if (!is_null($originatorName) && !is_string($originatorName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originatorName, true), gettype($originatorName)), __LINE__);
        }
        if (is_null($originatorName) || (is_array($originatorName) && empty($originatorName))) {
            unset($this->OriginatorName);
        } else {
            $this->OriginatorName = $originatorName;
        }
        return $this;
    }
    /**
     * Get PaymentReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPaymentReference()
    {
        return isset($this->PaymentReference) ? $this->PaymentReference : null;
    }
    /**
     * Set PaymentReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $paymentReference
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setPaymentReference($paymentReference = null)
    {
        // validation for constraint: string
        if (!is_null($paymentReference) && !is_string($paymentReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paymentReference, true), gettype($paymentReference)), __LINE__);
        }
        if (is_null($paymentReference) || (is_array($paymentReference) && empty($paymentReference))) {
            unset($this->PaymentReference);
        } else {
            $this->PaymentReference = $paymentReference;
        }
        return $this;
    }
    /**
     * Get Rate value
     * @return float|null
     */
    public function getRate()
    {
        return $this->Rate;
    }
    /**
     * Set Rate value
     * @param float $rate
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setRate($rate = null)
    {
        // validation for constraint: float
        if (!is_null($rate) && !(is_float($rate) || is_numeric($rate))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($rate, true), gettype($rate)), __LINE__);
        }
        $this->Rate = $rate;
        return $this;
    }
    /**
     * Get SettlementCurrencyID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSettlementCurrencyID()
    {
        return isset($this->SettlementCurrencyID) ? $this->SettlementCurrencyID : null;
    }
    /**
     * Set SettlementCurrencyID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $settlementCurrencyID
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setSettlementCurrencyID($settlementCurrencyID = null)
    {
        // validation for constraint: string
        if (!is_null($settlementCurrencyID) && !is_string($settlementCurrencyID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($settlementCurrencyID, true), gettype($settlementCurrencyID)), __LINE__);
        }
        if (is_null($settlementCurrencyID) || (is_array($settlementCurrencyID) && empty($settlementCurrencyID))) {
            unset($this->SettlementCurrencyID);
        } else {
            $this->SettlementCurrencyID = $settlementCurrencyID;
        }
        return $this;
    }
    /**
     * Get TransactionDate value
     * @return string|null
     */
    public function getTransactionDate()
    {
        return $this->TransactionDate;
    }
    /**
     * Set TransactionDate value
     * @param string $transactionDate
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setTransactionDate($transactionDate = null)
    {
        // validation for constraint: string
        if (!is_null($transactionDate) && !is_string($transactionDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionDate, true), gettype($transactionDate)), __LINE__);
        }
        $this->TransactionDate = $transactionDate;
        return $this;
    }
    /**
     * Get YourInternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getYourInternalReference()
    {
        return isset($this->YourInternalReference) ? $this->YourInternalReference : null;
    }
    /**
     * Set YourInternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $yourInternalReference
     * @return \StructType\DealPendingApprovalDetails
     */
    public function setYourInternalReference($yourInternalReference = null)
    {
        // validation for constraint: string
        if (!is_null($yourInternalReference) && !is_string($yourInternalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($yourInternalReference, true), gettype($yourInternalReference)), __LINE__);
        }
        if (is_null($yourInternalReference) || (is_array($yourInternalReference) && empty($yourInternalReference))) {
            unset($this->YourInternalReference);
        } else {
            $this->YourInternalReference = $yourInternalReference;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DealPendingApprovalDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
